#ifndef CPP_BOOPSI_LAYOUTIMAGES_H
#define CPP_BOOPSI_LAYOUTIMAGES_H

// Einige Schmuckelemente fr die Oberflche als BOOPSI Image Klassen
//
// Autor: Jochen Becher
//
// Historie:
// Version 1.0 am 26. Februar 94

#ifndef CPP_BOOPSI_BOOPSICLASS_H
#include <classes/boopsi/boopsiclass.h>
#endif

#ifndef CPP_BOOPSI_IMAGECLASS_H
#include <classes/boopsi/imageclass.h>
#endif

#ifndef INTUITION_IMAGECLASS_H
#include <intuition/imageclass.h>
#endif

#define LIA_Vertical      (TAG_USER+1)  // (I.G), BOOL

class LineiClass : public BoopsiClass {
public:
	LineiClass();
private:
	static ULONG dispatcher(Class *cl, Object *o, Msg msg);
	static ULONG renderLinei(Class *cl, struct Image *im,
		struct impDraw *msg, struct LineiData *);
};

class LineiC : public BoopsiImageC {
public:
	LineiC(Tag tag1type, ...)
		: BoopsiImageC(lic.boopsiclass(),NULL,(struct TagItem *) &tag1type) { };
	LineiC(struct TagItem *tags = NULL)
		: BoopsiImageC(lic.boopsiclass(),NULL,tags) { };
protected:
	LineiC(struct IClass *c, STRPTR pubclass, struct TagItem *tags)
		: BoopsiImageC(c,pubclass,tags) { };
public:
	static LineiClass lic;
};

// *************************************************************

#define PIA_Standard        (TAG_USER+1) // (ISG), ULONG

class PatterniClass : public BoopsiClass {
public:
	PatterniClass();
private:
	static ULONG dispatcher(Class *cl, Object *o, Msg msg);
	static ULONG render(Class *cl, struct Image *im,
		struct impDraw *msg, struct PatterniData *);
};

class PatterniC : public BoopsiImageC {
public:
	PatterniC(Tag tag1type, ...)
		: BoopsiImageC(pic.boopsiclass(),NULL,(struct TagItem *) &tag1type) { };
	PatterniC(struct TagItem *tags = NULL)
		: BoopsiImageC(pic.boopsiclass(),NULL,tags) { };
protected:
	PatterniC(struct IClass *c, STRPTR pubclass, struct TagItem *tags)
		: BoopsiImageC(c,pubclass,tags) { };
public:
	static PatterniClass pic;
};

// *************************************************************

#define TAPEIC_Play          1
#define TAPEIC_Wind          2
#define TAPEIC_Rewind        3
#define TAPEIC_Stop          4
#define TAPEIC_Pause         5
#define TAPEIC_Record        6
#define TAPEIC_PlayBackward  7
#define TAPEIC_Beginning     8
#define TAPEIC_End           9
#define TAPEIC_Repeat       10

#define TAPEIA_Number         (TAG_USER + 1) // (ISG), ULONG
#define TAPEIA_Plane          (TAG_USER + 2) // (ISG), BOOL
#define TAPEIA_Outline        (TAG_USER + 3) // (ISG), BOOL

class TapeImagesClass : public BoopsiClass {
public:
	TapeImagesClass();
private:
	static ULONG dispatcher(Class *cl, Object *o, Msg msg);
	static ULONG render(Class *cl, struct Image *im,
		struct impDraw *msg, struct TapeImagesData *);
};

class TapeImagesC : public BoopsiImageC {
public:
	TapeImagesC(Tag tag1type, ...)
		: BoopsiImageC(tic.boopsiclass(),NULL,(struct TagItem *) &tag1type) { };
	TapeImagesC(struct TagItem *tags = NULL)
		: BoopsiImageC(tic.boopsiclass(),NULL,tags) { };
protected:
	TapeImagesC(struct IClass *c, STRPTR pubclass, struct TagItem *tags)
		: BoopsiImageC(c,pubclass,tags) { };
public:
	static TapeImagesClass tic;
};

// *************************************************************

#define KEYIC_LeftAmiga     1
#define KEYIC_RightAmiga    2
#define KEYIC_Tab           3
#define KEYIC_ShiftTab      4
#define KEYIC_Backspace     5
#define KEYIC_CursorLeft    6
#define KEYIC_CursorRight   7
#define KEYIC_CursorUp      8
#define KEYIC_CursorDown    9
#define KEYIC_Return       10
#define KEYIC_Shift        11

#define KEYIA_Number         (TAG_USER + 1) // (ISG), ULONG
#define KEYIA_Plane          (TAG_USER + 2) // (ISG), BOOL
#define KEYIA_Outline        (TAG_USER + 3) // (ISG), BOOL

class KeyboardImagesClass : public BoopsiClass {
public:
	KeyboardImagesClass();
private:
	static ULONG dispatcher(Class *cl, Object *o, Msg msg);
	static ULONG render(Class *cl, struct Image *im,
		struct impDraw *msg, struct KeyboardImagesData *);
};

class KeyboardImagesC : public BoopsiImageC {
public:
	KeyboardImagesC(Tag tag1type, ...)
		: BoopsiImageC(kic.boopsiclass(),NULL,(struct TagItem *) &tag1type) { };
	KeyboardImagesC(struct TagItem *tags = NULL)
		: BoopsiImageC(kic.boopsiclass(),NULL,tags) { };
protected:
	KeyboardImagesC(struct IClass *c, STRPTR pubclass, struct TagItem *tags)
		: BoopsiImageC(c,pubclass,tags) { };
public:
	static KeyboardImagesClass kic;
};

// *************************************************************

#define GUIIC_FileSelect   1
#define GUIIC_PopupMenu    2
#define GUIIC_PopupSelect  3
#define GUIIC_Ok           4
#define GUIIC_Cancel       5

#define GUIIA_Number       (TAG_USER + 1) // (ISG), ULONG
#define GUIIA_Plane        (TAG_USER + 2) // (ISG), BOOL
#define GUIIA_Outline      (TAG_USER + 3) // (ISG), BOOL

class GUIImagesClass : public BoopsiClass {
public:
	GUIImagesClass();
private:
	static ULONG dispatcher(Class *cl, Object *o, Msg msg);
	static ULONG render(Class *cl, struct Image *im,
		struct impDraw *msg, struct GUIImagesData *);
};

class GUIImagesC : public BoopsiImageC {
public:
	GUIImagesC(Tag tag1type, ...)
		: BoopsiImageC(kic.boopsiclass(),NULL,(struct TagItem *) &tag1type) { };
	GUIImagesC(struct TagItem *tags = NULL)
		: BoopsiImageC(kic.boopsiclass(),NULL,tags) { };
protected:
	GUIImagesC(struct IClass *c, STRPTR pubclass, struct TagItem *tags)
		: BoopsiImageC(c,pubclass,tags) { };
public:
	static GUIImagesClass kic;
};

// *************************************************************

#define PICA_Image        (TAG_USER + 1) // (ISG), struct Image *

class PictureClass : public BoopsiClass {
public:
	PictureClass();
private:
	static ULONG dispatcher(Class *cl, Object *o, Msg msg);
	static ULONG render(Class *cl, struct Image *im,
		struct impDraw *msg, struct InstanceData *);
};

class PictureC : public BoopsiImageC {
public:
	PictureC(Tag tag1type, ...)
		: BoopsiImageC(pic.boopsiclass(),NULL,(struct TagItem *) &tag1type) { };
	PictureC(struct TagItem *tags = NULL)
		: BoopsiImageC(pic.boopsiclass(),NULL,tags) { };
protected:
	PictureC(struct IClass *c, STRPTR pubclass, struct TagItem *tags)
		: BoopsiImageC(c,pubclass,tags) { };
public:
	static PictureClass pic;
};

#endif
