#ifndef CPP_DOS_DOS_H
#define CPP_DOS_DOS_H

// Basisklasse fr Dos Objekte
//
// Autor: Jochen Becher
//
// Historie:
// Version 1.0 am 28. Juni 94

#ifndef DOS_DOS_H
#include <dos/dos.h>
#endif

#ifndef DOS_DOSEXTENS_H
#include <dos/dosextens.h>
#endif

#ifndef CPP_EXEC_SHARE_H
#include <classes/exec/share.h>
#endif

#ifndef CPP_UTILITY_TAGITEM_H
#include <classes/utility/tagitem.h>
#endif

#ifndef CPP_EXCEPTIONS_EXCEPTIONS_H
#include <classes/exceptions/exceptions.h>
#endif

class DosObjectC : protected ShareC {
public:
	DosObjectC(ULONG type, struct TagItem *tags = NULL) throw (DosObjectX, MemoryX);
	DosObjectC(ULONG type, Tag tag1type, ...) throw (DosObjectX, MemoryX);
	DosObjectC(ULONG type, APTR object) throw (DosObjectX, MemoryX);
	DosObjectC(const DosObjectC &);
	~DosObjectC();
	DosObjectC &operator= (const DosObjectC &);
	APTR object() const { return dosobject; };
private:
	APTR dosobject;
	ULONG dostype;
	BOOL priv;
};

#endif
