#ifndef CPP_DATASTRUCTURES_BUFFER_H
#define CPP_DATASTRUCTURES_BUFFER_H

// Ein dynamischer Datenpuffer
//
// Autor: Jochen Becher
//
// Historie:
// Version 1.0 am 25. Juni 94

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif

#ifndef CPP_EXCEPTIONS_EXCEPTIONS_H
#include <classes/exceptions/exceptions.h>
#endif

class BufferC {
public:
	BufferC(ULONG initsize = 256) throw (MemoryX);
	BufferC(APTR buffer, ULONG bufsize) throw (MemoryX);
	BufferC(const BufferC &) throw (MemoryX);
	~BufferC();
	BufferC &operator= (const BufferC &) throw (MemoryX);
	APTR buffer() const { return databuffer; };
	ULONG size() const { return databuffer ? buffersize : 0; };
	VOID doubleBuffer() throw (MemoryX);
	VOID setBufferSize(ULONG newsize) throw (MemoryX);
private:
	APTR databuffer;
	ULONG buffersize;
	BOOL privBuffer;
};

#endif
