#ifndef CPP_INTUITION_REQUESTER_H
#define CPP_INTUITION_REQUESTER_H

// Requester Klassen
//
// Autor: Jochen Becher
//
// Historie:
// Version 1.0, am 10. Januar 94

#ifndef INTUITION_INTUITION_H
#include <intuition/intuition.h>
#endif

#ifndef INCLUDE_TOOLS_STR_H
#include <tools/str.h>
#endif

#ifndef CPP_INTUITION_WINDOW_H
#include <classes/intuition/window.h>
#endif

class EasyRequesterC {
public:
	EasyRequesterC(WindowC *, ULONG idcmpFlags,
		STRPTR title, STRPTR gadgettext);
	LONG request(STRPTR text, APTR args = NULL);
	LONG request(STRPTR text, ULONG arg1, ...);
protected:
	WindowC *window;
	ULONG idcmp;
	struct EasyStruct easy;
};

class InfoRequesterC : public EasyRequesterC {
public:
	InfoRequesterC(WindowC *, STRPTR title, STRPTR gadget);
	VOID request(STRPTR text, APTR args = NULL);
	VOID request(STRPTR text, ULONG arg1, ...);
};

class TwoButtonRequesterC : public EasyRequesterC {
public:
	TwoButtonRequesterC(WindowC *, STRPTR title, STRPTR left, STRPTR right);
	BOOL request(STRPTR text, APTR args = NULL);
	BOOL request(STRPTR text, ULONG arg1, ...);
private:
	String gadgettext;
};

class ThreeButtonRequesterC : public EasyRequesterC {
public:
	ThreeButtonRequesterC(WindowC *, STRPTR title,
		STRPTR left, STRPTR middle, STRPTR right);
	ULONG request(STRPTR text, APTR args = NULL);
	ULONG request(STRPTR text, ULONG arg1, ...);
private:
	String gadgettext;
};

#endif